import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Lopta poletujúca priestorom
 */
public class Lopta extends MojAktor
{
    private Smer smer;
    private Platforma poslednaPlatforma;

    /**
     * Vytvorí preddefinovanú loptu idúcu doprava hore rýchlosťou 10.
     */
    public Lopta()
    {
        super(10);
        smer =  new Smer(-1, 1);
        poslednaPlatforma = null;
    }

    /**
     * Odrazí sa a pohne sa ďalej.
     */
    public void act()
    {
        /* dotkol som sa od spodku/vrchu - skončila hra*/
        if (jeNaHornomOkraji() || jeNaDolnomOkraji()) {
            Greenfoot.stop();
            return;
        }
        /* odrazam sa od bokov*/
        if (jeNaLavomOkraji() || jeNaPravomOkraji()) {
            smer.odrazVertikalne();
        }
        /* odrážam sa od platformy*/
        if (isTouching(Platforma.class)) {
            Platforma platformaKtorejSaDotykam = (Platforma)getOneIntersectingObject(Platforma.class);
            if (poslednaPlatforma != platformaKtorejSaDotykam) {
                poslednaPlatforma = platformaKtorejSaDotykam;
                smer.odrazHorizontalne();
            }
        }
        /* nastavím svoj smer a pohnem sa*/
        setRotation(smer.getUhol());
        move(dajRychlost());
    }

    /**
     * Vráti platformu, od ktorej sa ako posledná odrazila
     */
    public Platforma dajPoslednuPlatformu()
    {
        return poslednaPlatforma;
    }
}
