import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Predok aktorov, ktorý vie odpovedať na jednoduché otázky.
 */
public class MojAktor extends Actor
{
    private int rychlost;

    /**
     * Vytvorí aktora, ktorý sa pohybuje rýchlosťou
     */
    public MojAktor(int pociatocnaRychlost)
    {
        rychlost = pociatocnaRychlost;
    }

    /**
     * Vráti šírku aktora (berie sa šírka obrázka).
     */
    public int sirka()
    {
        return getImage().getWidth();
    }

    /**
     * Vráti výšku aktora (berie sa výška obrázka).
     */
    public int vyska()
    {
        return getImage().getHeight();
    }

    /**
     * Zistí, či sa aktor nachádza na ľavom okraji.
     */
    public boolean jeNaLavomOkraji()
    {
        return getX() - sirka() / 2 <= 2;
    }

    /**
     * Zistí, či sa aktor nachádza na pravom okraji.
     */
    public boolean jeNaPravomOkraji()
    {
        return getX() + sirka() / 2 >= getWorld().getWidth() - 2;
    }

    /**
     * Zistí, či sa aktor nachádza na hornom okraji.
     */
    public boolean jeNaHornomOkraji()
    {
        return getY() - vyska() / 2 <= 2;
    }

    /**
     * Zistí, či sa aktor nachádza na dolnom okraji.
     */
    public boolean jeNaDolnomOkraji()
    {
        return getY() + vyska() / 2 >= getWorld().getHeight() - 2;
    }

    /**
     * Vráti rýchlosť.
     */
    public int dajRychlost()
    {
        return rychlost;
    }

    /**
     * Nastaví rýchlosť.
     */
    public void nastavRychlost(int novaRychlost)
    {
        rychlost = novaRychlost;
    }
}
