import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * Trieda zapúzdruje základné interakcie s prostredím.
 */
public class Ovladanie
{
    public static final String SIPKA_DOLAVA = "left";
    public static final String SIPKA_DOPRAVA = "right";
    public static final String SIPKA_HORE = "up";
    public static final String SIPKA_DOLE = "down";
    
    public static final String ENTER = "enter";
    public static final String MEDZERNIK = "space";
    public static final String TABULATOR = "tab";
    public static final String ESCAPE = "escape";
    public static final String BACKSPACE = "backspace";
    public static final String SHIFT = "shift";
    public static final String CONTROL = "control";

    /**
     * Overí, či je stlačená šípka doľava.
     */
    static public boolean jeStlacenaSipkaDolava()
    {
        return Ovladanie.jeStlacenaKlavesa(SIPKA_DOLAVA);
    }

    /**
     * Overí, či je stlačená šípka doprava.
     */
    static public boolean jeStlacenaSipkaDoprava()
    {
        return Ovladanie.jeStlacenaKlavesa(SIPKA_DOPRAVA);
    }

    /**
     * Overí, či je stlačená šípka hore.
     */
    static public boolean jeStlacenaSipkaHore()
    {
        return Ovladanie.jeStlacenaKlavesa(SIPKA_HORE);
    }

    /**
     * Overí, či je stlačená šípka dole.
     */
    static public boolean jeStlacenaSipkaDore()
    {
        return Ovladanie.jeStlacenaKlavesa(SIPKA_DOLE);
    }

    /**
     * Overí, či je stlačená daná klávesa.
     */
    static public boolean jeStlacenaKlavesa(String klavesa)
    {
        return Greenfoot.isKeyDown(klavesa);
    }
}
