import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Platforma slúžiaca na odrážanie lopty.
 */
public class Platforma extends MojAktor
{
    private String dolava;
    private String doprava;
    private String natocenieDolava;
    private String natocenieDoprava;

    /**
     * Vtvorí platformu, ktorá je ovládaná danými klávesami.
     */
    public Platforma(String ovladanieDolava, String ovladanieDoprava, String ovladanieNatocenieDolava, String ovladanieNatocenieDoprava)
    {
        super(5);
        dolava = ovladanieDolava;
        doprava = ovladanieDoprava;
        natocenieDolava = ovladanieNatocenieDolava;
        natocenieDoprava = ovladanieNatocenieDoprava;
    }

    /**
     * Vráti klávesu, ktorou sa ovláda smerom doľava.
     */
    public String dajKlavesuDolava()
    {
        return dolava;
    }

    /**
     * Vráti klávesu, ktorou sa ovláda smerom doprava.
     */
    public String dajKlavesuDoprava()
    {
        return doprava;
    }

    /**
     * Nastaví klávesu pre ovládanie doprava.
     */
    public void nastavDoprava(String novaHodnota)
    {
        doprava = novaHodnota;
    }

    /**
     * Nastaví klávesu pre ovládanie doľava.
     */
    public void nastavDolava(String novaHodnota)
    {
        dolava = novaHodnota;
    }

    /**
     * Na základe stlačenej klávesy pohne platformu, pričom kontroluje, aby neprešla za okraj.
     */
    public void act()
    {
        if (Ovladanie.jeStlacenaKlavesa(dolava) && ! jeNaLavomOkraji()) {
            move( - dajRychlost());
        }
        if (Ovladanie.jeStlacenaKlavesa(doprava) && ! jeNaPravomOkraji()) {
            move(dajRychlost());
        }
    }
}
