import greenfoot.Greenfoot;

public class Genom  
{
    public static final int POCET_GENOV = 12;

    private Gen[] geny;
    
    private Genom()
    {
        this.geny = new Gen[Genom.POCET_GENOV];
        
        for (int i = 0; i < Genom.POCET_GENOV; i++) {
            this.geny[i] = new Gen();
        }
    }
    
    public static Genom vytvorPrazdnyGenom() {
        Genom vyslednyGenom = new Genom();
        return vyslednyGenom;
    }
    
    public static Genom vytvorNahodnyGenom() {
        Genom vyslednyGenom = new Genom();
        
        for (int i = 0; i < Genom.POCET_GENOV; i++) {
            Gen gen = vyslednyGenom.getGen(i);
            gen.nastavNahodneRGB();
        }
        
        return vyslednyGenom;
    }
    
    public static Genom vytvorKrasnyGenom() {
        Genom vyslednyGenom = new Genom();
        
        vyslednyGenom.getGen(0).setRGB(255, 0, 0);
        vyslednyGenom.getGen(1).setRGB(255, 125, 0);
        vyslednyGenom.getGen(2).setRGB(255, 255, 0);
        vyslednyGenom.getGen(3).setRGB(125, 255, 0);
        vyslednyGenom.getGen(4).setRGB(0, 255, 0);
        vyslednyGenom.getGen(5).setRGB(0, 255, 125);
        vyslednyGenom.getGen(6).setRGB(0, 255, 255);
        vyslednyGenom.getGen(7).setRGB(0, 125, 255);
        vyslednyGenom.getGen(8).setRGB(0, 0, 255);
        vyslednyGenom.getGen(9).setRGB(125, 0, 255);
        vyslednyGenom.getGen(10).setRGB(255, 0, 255);
        vyslednyGenom.getGen(11).setRGB(255, 0, 125);
        
        return vyslednyGenom;
    }
    
    public Genom vratKopiu() {
        Genom vyslednyGenom = new Genom();
        
        for (int i = 0; i < Genom.POCET_GENOV; i++) {
            Gen mojGen = this.geny[i];
            Gen vyslednyGen = vyslednyGenom.getGen(i);
                 
            vyslednyGen.nastavRGB(mojGen);
        }
        
        return vyslednyGenom;
    }
    
    public Gen getGen(int ktory) {
        return this.geny[ktory];
    }

    public double odlisnost(Genom genomNaPorovnanie) {
        double vysledok = 0;
        for (int i = 0; i < Genom.POCET_GENOV; i++) {
            Gen mojGen = this.geny[i];
            Gen porovnavanyGen = genomNaPorovnanie.getGen(i);
            vysledok += mojGen.odlisnost(porovnavanyGen);
        }
        return vysledok;
    }
    
    public void sparujGeny(Genom genomNaParenie) {
        for (int i = 0; i < Genom.POCET_GENOV; i++) {
            Gen mojGen = this.geny[i];
            Gen genNaParenie = genomNaParenie.getGen(i);
            Gen krasnyGen = Miska.KRASNY_GENOM.getGen(i);
            
            int nahoda = Greenfoot.getRandomNumber(100);
            
            // s pravdepodobnostou 10% gen uplne zmutuje
            if (nahoda < 10) {
                mojGen.nastavNahodneRGB();
            } else 
            // s pravdepodobnostou 70% sa prevezme krajsi gen, ak je krajsi
            if (nahoda < 70) {           
                if (genNaParenie.odlisnost(krasnyGen) < mojGen.odlisnost(krasnyGen)) {
                    mojGen.nastavRGB(genNaParenie);
                }
            }
            // s pravdepodobnostou 20% sa ponecha povodny gen
        }
    }
}
