import greenfoot.Color;
import java.util.ArrayList;

public class Pravidla  
{
    
    private ArrayList<Pravidlo> pravidla;
    
    private Pravidla() {
        this.pravidla = new ArrayList<>();
    }
    
    public static Pravidla vytvorRL() {
        Pravidla vysledok = new Pravidla();
        vysledok.pridajPravidlo(Otocenie.DOPRAVA, new Color(102, 255, 0));
        vysledok.pridajPravidlo(Otocenie.DOLAVA, new Color(255, 102, 0));
        return vysledok;
    }
    
    public static Pravidla vytvorRLR() {
        Pravidla vysledok = new Pravidla();
        vysledok.pridajPravidlo(Otocenie.DOPRAVA, new Color(102, 255, 0));
        vysledok.pridajPravidlo(Otocenie.DOLAVA, new Color(102, 255, 255));
        vysledok.pridajPravidlo(Otocenie.DOPRAVA, new Color(255, 255, 0));
        return vysledok;
    }
    
    public static Pravidla vytvorLLRR() {
        Pravidla vysledok = new Pravidla();
        vysledok.pridajPravidlo(Otocenie.DOLAVA, new Color(102, 255, 0));
        vysledok.pridajPravidlo(Otocenie.DOLAVA, new Color(102, 255, 255));
        vysledok.pridajPravidlo(Otocenie.DOPRAVA, new Color(255, 255, 0));
        vysledok.pridajPravidlo(Otocenie.DOPRAVA, new Color(255, 102, 0));
        return vysledok;
    }

    public int pocetPravidiel() {
        return this.pravidla.size();
    }
    
    public Pravidlo getPravidlo(int ktore) {
        return this.pravidla.get(ktore % this.pocetPravidiel());
    }
    
    public Pravidlo nasledujuce(Pravidlo pravidlo) {
        if (pravidlo == null) {
            return this.pravidla.get(0);
        } else {
            return this.pravidla.get((pravidlo.index + 1) % this.pocetPravidiel());
        }
    }
    
    public void pridajPravidlo(Otocenie otocenie, Color farba) {
        this.pravidla.add(new Pravidlo(otocenie, farba, this.pocetPravidiel()));
    }
    
}
