public enum Smer  
{
    HORE(0, -1, 270),
    DOLE(0, 1, 90),
    DOPRAVA(1, 0, 0),
    DOLAVA(-1, 0, 180);
    
    private int deltaX;
    private int deltaY;
    private int uhol;
    
    private Smer(int deltaX, int deltaY, int uhol) {
        this.deltaX = deltaX;
        this.deltaY = deltaY;
        this.uhol = uhol;
    }
    
    public int getDeltaX() {
        return this.deltaX;
    }
    
    public int getDeltaY() {
        return this.deltaY;
    }
    
    public int getUhol() {
        return this.uhol;
    }
    
    public static Smer doprava(Smer smer) {
        switch(smer) {
            case HORE: return DOPRAVA;
            case DOPRAVA: return DOLE;
            case DOLE: return DOLAVA;
            case DOLAVA: return HORE;
            default: return null;
        }
    }
    
    public static Smer dolava(Smer smer) {
        switch(smer) {
            case HORE: return DOLAVA;
            case DOLAVA: return DOLE;
            case DOLE: return DOPRAVA;
            case DOPRAVA: return HORE;
            default: return null;
        }
    }
    
    public static Smer smerPoOtoceni(Smer smer, Otocenie otocenie) {
        switch (otocenie) {
            case DOPRAVA: return Smer.doprava(smer);
            case DOLAVA: return Smer.dolava(smer);
            default: return smer;
        }
    }
    
}
