import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Svet extends World
{
    private static final int DLZKA_X = 51;
    private static final int DLZKA_Y = 51;
    
    private Bunka[][] bunky;
    
    public Svet()
    {    
        super(Svet.DLZKA_X, Svet.DLZKA_Y, Bunka.VELKOST);
        
        this.bunky = new Bunka[Svet.DLZKA_X][Svet.DLZKA_Y];
        
        Pravidla pravidla = Pravidla.vytvorLLRR();
        //Pravidla pravidla = Pravidla.vytvorRL();
        //Pravidla pravidla = Pravidla.vytvorRLR();
        
        for (int x = 0; x < Svet.DLZKA_X; x++) {
            for (int y = 0; y < Svet.DLZKA_Y; y++) {
                this.bunky[x][y] = new Bunka();
                this.addObject(this.bunky[x][y], x, y);
            }
        }
        
        //this.vlozMravca(25, 10, Smer.DOPRAVA, pravidla);
        //this.vlozMravca(75, 40, Smer.DOLAVA, pravidla);        
        //this.vlozMravca(25, 40, Smer.HORE, pravidla);
        //this.vlozMravca(75, 10, Smer.DOLE, pravidla);        
        
        this.vlozMravca(25, 25, Smer.DOLE, pravidla); 
    }
    
    public final Bunka dajBunkuNaSuradniciach(int x, int y) {
        x = x % Svet.DLZKA_X;
        if (x < 0) {
            x += Svet.DLZKA_X;
        }
        
        y = y % Svet.DLZKA_Y;
        if (y < 0) {
            y += Svet.DLZKA_Y;
        }
        
        return this.bunky[x][y];
    }
    
    public final Bunka dajBunkuVSmere(Bunka pociatocna, Smer smer) {
        return this.dajBunkuNaSuradniciach(pociatocna.getX() + smer.getDeltaX(), pociatocna.getY() + smer.getDeltaY());
    }
    
    public final void vlozMravca(int x, int y, Smer smer, Pravidla pravidla) {
        Bunka b = this.dajBunkuNaSuradniciach(x, y);
        Mravec mravec = new Mravec(b, smer, pravidla); 
        this.addObject(mravec, b.getX(), b.getY());
    }
}
