import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Aktor, ktorý vie reagovať na šípky, pohyb myšou. Ďalej  vie meniť svoju polohu a zistiť, či sa nachádza na hraniciach sveta. 
 */
public abstract class OvladaciAktor extends Actor
{

    /**
     * Šablónová metóda definujúca činnosť aktora. Najskôr zareaguje na stlačenie kláves, potom na pohyb myši a nakoniec nechá vykonať nejakú činnosť.
     */
    final public void act()
    {
        if (Greenfoot.isKeyDown("left")) {
            stlacenaSipkaDolava();
        }
        if (Greenfoot.isKeyDown("right")) {
            stlacenaSipkaDoprava();
        }
        if (Greenfoot.isKeyDown("up")) {
            stlacenaSipkaHore();
        }
        if (Greenfoot.isKeyDown("down")) {
            stlacenaSipkaDole();
        }
        if (Greenfoot.mouseMoved(null)) {
            MouseInfo info = Greenfoot.getMouseInfo();
            myskaSaPohla(info.getX(), info.getY());
        }
        if (Greenfoot.mouseClicked(null)) {
            MouseInfo info = Greenfoot.getMouseInfo();
            myskaKlikla(info.getX(), info.getY());
        }
        konaj();
    }

    /**
     * Volá sa pravidelne.
     */
    public void konaj()
    {
    }

    /**
     * Volá sa ak sa stlačí šípka doľava.
     */
    public void stlacenaSipkaDolava()
    {
    }

    /**
     * Volá sa ak sa stlačí šípka doprava.
     */
    public void stlacenaSipkaDoprava()
    {
    }

    /**
     * Volá sa ak sa stlačí šípka hore.
     */
    public void stlacenaSipkaHore()
    {
    }

    /**
     * Volá sa ak sa stlačí šípka dole.
     */
    public void stlacenaSipkaDole()
    {
    }

    /**
     * Volá sa ak sa pohne myška. V parametroch je uložená aktuálna pozícia myšky vo svete.
     */
    public void myskaSaPohla(int poziciaX, int poziciaY)
    {
    }

    /**
     * Volá sa ak sa kliklo myškou. V parametroch je uložená aktuálna pozícia myšky vo svete.
     */
    public void myskaKlikla(int poziciaX, int poziciaY)
    {
    }

    /**
     * Posunie sa v horizontálnom smere zo svojej aktuálnej pozície.
     */
    final public void posunSaHorizontalne(int oKolko)
    {
        setLocation(getX() + oKolko, getY());
    }

    /**
     * Posunie sa vo vertikálnom smere zo svojej aktuálnej pozície.
     */
    final public void posunSaVertikalne(int oKolko)
    {
        setLocation(getX(), getY() + oKolko);
    }

    /**
     * Zmení svoju X polohu vo svete.
     */
    final public void zmenPolohuX(int noveX)
    {
        this.setLocation(noveX, getY());
    }

    /**
     * Zmení svoju Y polohu vo svete.
     */
    final public void zmenPolohuY(int noveY)
    {
        this.setLocation(getX(), noveY);
    }

    /**
     * Vráti šírku aktora.
     */
    public int sirka()
    {
        return getImage().getWidth();
    }

    /**
     * Vráti výšku aktora.
     */
    public int vyska()
    {
        return getImage().getHeight();
    }

    /**
     * Zistí, či je aktor na hornom okraji sveta.
     */
    final public boolean jeNaHornomOkraji()
    {
        return getY() - vyska() / 2 <= 0;
    }

    /**
     * Zistí, či je aktor na dolnom okraji sveta.
     */
    final public boolean jeNaDolnomOkraji()
    {
        return getY() + vyska() / 2 >= getWorld().getHeight();
    }

    /**
     * Zistí, či je aktor na ľavom okraji sveta.
     */
    final public boolean jeNaLavomOkraji()
    {
        return getX() - sirka() / 2 <= 0;
    }

    /**
     * Zistí, či je aktor na pravom okraji sveta.
     */
    final public boolean jeNaPravomOkraji()
    {
        return getX() + sirka() / 2 >= getWorld().getWidth();
    }

    /**
     * Odstráni sa zo sveta.
     */
    final public void odstranSaZoSveta()
    {
        getWorld().removeObject(this);
    }
}
