import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Nota here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Nota extends Actor
{
    
    private final Ton ton;
    private final Doba doba;
    private boolean zapisana;
    private boolean zaznela;
    
    private int vychylenieStredX;
    private int vychylenieStredY;
    
    public Nota(Ton ton, Doba doba) {
        this.ton = ton;
        this.doba = doba;
        
        this.zapisana = false;
        this.zaznela = false;
        
        this.nakresliSa();
    }
    
    public Ton getTon() {
        return this.ton;
    }
    
    public Doba getDoba() {
        return this.doba;
    }
    
    public int getVychylenieStredX() {
        return this.vychylenieStredX;
    }
    
    public int getVychylenieStredY() {
        return this.vychylenieStredY;
    }
    
    public boolean jeZapisana() {
        return this.zapisana;
    }
    
    public boolean zaznela() {
        return this.zaznela;
    }
    
    public void zapis() {
        this.zapisana = true;
    }
    
    /**
     * Act - do whatever the Nota wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    { 
        this.move(-1);
        if (this.isAtEdge()) {
            this.getWorld().removeObject(this);
            //this.zaznej();
        }        
    }    
    
    public void zaznej() {
        this.ton.zaznej();
        this.zaznela = true;
        this.nakresliSa();
    }
    
    private void nakresliSa() {
        boolean maNozicku = this.doba != Doba.CELA;
        boolean maVlajocku = maNozicku && (this.doba == Doba.OSMINOVA || this.doba == Doba.SESTNASTINOVA);
        
        int sirkaObrazka = maVlajocku ? NotovaOsnova.SIRKA_BRUSKA + NotovaOsnova.SIRKA_VLAJOCKY : NotovaOsnova.SIRKA_BRUSKA;
        int vyskaObrazka = maNozicku ?  NotovaOsnova.VYSKA_MEDZERY / 2 + NotovaOsnova.VYSKA_NOZICKY : NotovaOsnova.VYSKA_MEDZERY;
        
        GreenfootImage obrazok = this.getImage();
        obrazok.scale(sirkaObrazka, vyskaObrazka);
        obrazok.clear();
        obrazok.setColor(this.zaznela ? Color.GREEN : Color.BLACK);
        
        switch (this.doba) {
            case SESTNASTINOVA: 
                obrazok.drawLine(NotovaOsnova.SIRKA_BRUSKA - 1, 10, sirkaObrazka - 1, 20); 
                obrazok.drawLine(sirkaObrazka - 1, 20, sirkaObrazka - 1, 50); 
            case OSMINOVA: 
                obrazok.drawLine(NotovaOsnova.SIRKA_BRUSKA - 1, 0, sirkaObrazka - 1, 10); 
                obrazok.drawLine(sirkaObrazka - 1, 10, sirkaObrazka - 1, 40); 
            case STVRTOVA: 
                obrazok.fillOval(0, vyskaObrazka - NotovaOsnova.VYSKA_MEDZERY, NotovaOsnova.SIRKA_BRUSKA - 1, NotovaOsnova.VYSKA_MEDZERY - 1); // plne brusko
            case POLOVA: 
                obrazok.drawLine(NotovaOsnova.SIRKA_BRUSKA - 1, 0, NotovaOsnova.SIRKA_BRUSKA - 1, NotovaOsnova.VYSKA_NOZICKY - 1); // nozicka
            case CELA: 
                obrazok.drawOval(0, vyskaObrazka - NotovaOsnova.VYSKA_MEDZERY, NotovaOsnova.SIRKA_BRUSKA - 1, NotovaOsnova.VYSKA_MEDZERY - 1); // prazdne brusko
        }
        
        this.vychylenieStredX = -(NotovaOsnova.SIRKA_BRUSKA / 2);
        this.vychylenieStredY = maNozicku ? -((2 * NotovaOsnova.VYSKA_NOZICKY + NotovaOsnova.VYSKA_MEDZERY) / 4) + NotovaOsnova.VYSKA_MEDZERY / 2 : 0;
        
    }
}
