import java.util.List;
import java.util.ArrayList;

public class Takt  
{
    private int pocetDob;
    private Doba doba;

    private List<Nota> noty;
    
    public Takt(int pocetDob, Doba doba) {
        this.pocetDob = pocetDob;
        this.doba = doba;
        
        this.noty = new ArrayList<Nota>();
    }
    
    public boolean jeOK() {
        return this.trvanieNot() == this.trvanieTaktu();
    }

    public int trvanieTaktu() {
        return this.doba.getTrvanie() * this.pocetDob;
    }
    
    public int trvanieNot() {
        int spolu = 0;
        
        for(Nota nota : this.noty) {
            spolu += nota.getDoba().getTrvanie();
        }
        
        return spolu;
    }
    
    public Nota pridaj(Ton ton, Doba doba) {
        if (doba.getTrvanie() + this.trvanieNot() <= this.trvanieTaktu()) {
            Nota nota = new Nota(ton, doba);
            this.noty.add(nota);
            return nota;
        } else {
            return null;
        }
    }
    
    public Nota dajNotuVCase(int cas) {       
        for (Nota nota : this.noty) {
            cas -= nota.getDoba().getTrvanie();
            if (cas <= 0)   
                return nota;
        }
        
        return null;
    }
}
