// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Vesmírny aktor reprezentujúci bombu, zhadzovanú votrelcami. Automaticky padá smerom na Zem. Informuje cieľ o zásahu. Po zásahu sa odstráni z vesmíru
 */
public class Bomba extends VesmirnyAktor
{
    private int typ;
    private int rychlost;
    private int pocitadlo;
    private boolean stavPohybu;
    private GreenfootImage[] obrazky;

    /**
     * Vytvorí bombu náhodného typu
     */
    public Bomba()
    {
        this.typ = Greenfoot.getRandomNumber(2);
        this.rychlost = 1;
        this.obrazky =  new GreenfootImage[2];
        nastavObrazky();
        zmenObrazok();
    }

    /**
     * Vykoná pohyb bomby smerom k Zemy. Pri páde kontroluje kontakt s cieľom. Po zásahu sa odstráni z vesmíru.
     */
    public void akcia()
    {
        if (jeAktivny()) {
            if (this.pocitadlo == this.rychlost) {
                posunDole(1);
                if (zasiahlaCiel()) {
                    Vesmir vesmir = dajVesmir();
                    if (vesmir != null) {
                        vesmir.odstranAktora(this);
                    }
                }
                zmenObrazok();
                this.pocitadlo = 0;
            }
            this.pocitadlo = this.pocitadlo + 1;
        }
    }

    /**
     * Zistí, či bomba zasiahla nejaký cieľ (Kanon,Zem,Bariera). Ak zasiahla cieľ, informuje ho o zásahu.
     */
    public boolean zasiahlaCiel()
    {
        Kanon kanon = (Kanon)getOneIntersectingObject(Kanon.class);
        if (kanon != null) {
            kanon.zasah();
            return true;
        }
        Zem zem = (Zem)getOneIntersectingObject(Zem.class);
        if (zem != null) {
            return true;
        }
        Bariera bariera = (Bariera)getOneIntersectingObject(Bariera.class);
        if (bariera != null) {
            bariera.zasah();
            return true;
        }
        return false;
    }

    /**
     * Nastaví obrázky stavu bomby podľa jej typu
     */
    private void nastavObrazky()
    {
        switch (this.typ) {
            case 0 : {
                this.obrazky[0] =  new GreenfootImage("images\\bomba1_0.png");
                this.obrazky[1] =  new GreenfootImage("images\\bomba1_1.png");
                break;
            }
            case 1 : {
                this.obrazky[0] =  new GreenfootImage("images\\bomba2_0.png");
                this.obrazky[1] =  new GreenfootImage("images\\bomba2_1.png");
                break;
            }
        }
    }

    /**
     * Prepína medzi obrázkami stavu pohybu
     */
    public void zmenObrazok()
    {
        if (this.stavPohybu) {
            nastavObrazok(this.obrazky[1]);
            this.stavPohybu = false;
        }
        else {
            nastavObrazok(this.obrazky[0]);
            this.stavPohybu = true;
        }
    }
}
