// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * Trieda reprezentujúca formáciu votrelcov. Formácia je zložená z 55 votrelcov v 5 riadkoch a 11 stĺpcoch (prvý riadok - GENERAL, druhý a tretí - KAPITAN, štvrtý a piaty - VOJAK). Synchronizuje smer pohybu medzi votrelcami. Riadi proces bombardovania (výber votrelca a zhodenie bomby).
 */
public class Formacia
{
    private final int STLPCE = 11;
    private final int RIADKY = 5;
    private Vesmir vesmir;
    private Votrelec[][] votrelci;
    private int pocetAktivnychVotrelcov;
    private boolean smerPohybu;
    private boolean potrebaZmenyPohybu;

    /**
     * Vytvorí formáciu votrelcov vo vesmíre
     */
    public Formacia(Vesmir vesmir)
    {
        this.vesmir = vesmir;
        this.votrelci =  new Votrelec[STLPCE][RIADKY];
        vytvorFormaciu();
    }

    /**
     * Pridá votrelcov do formácie
     */
    public void vytvorFormaciu()
    {
        int stlpec = 0;
        int riadok = 0;
        while (riadok < RIADKY) {
            while (stlpec < STLPCE) {
                int typ;
                switch (riadok) {
                    case 0 : {
                        typ = Votrelec.GENERAL;
                        break;
                    }
                    case 1 : {
                        typ = Votrelec.KAPITAN;
                        break;
                    }
                    case 2 : {
                        typ = Votrelec.KAPITAN;
                        break;
                    }
                    case 3 : {
                        typ = Votrelec.VOJAK;
                        break;
                    }
                    case 4 : {
                        typ = Votrelec.VOJAK;
                        break;
                    }
                    default : {
                        typ = 0;
                    }
                }
                Votrelec votrelec =  new Votrelec(this, typ);
                this.votrelci[stlpec][riadok] = votrelec;
                vesmir.pridajAktora(votrelec, 25 + (stlpec * 17), 50 + (riadok * 17));
                this.pocetAktivnychVotrelcov = this.pocetAktivnychVotrelcov + 1;
                stlpec = stlpec + 1;
            }
            riadok = riadok + 1;
            stlpec = 0;
        }
    }

    /**
     * Nastaví potrebu zmeny smeru pohybu
     */
    public void nastavPotrebuZmenyPohybu()
    {
        this.potrebaZmenyPohybu = true;
    }

    /**
     * Zistí, či je potrebná zmena smeru pohybu
     */
    public boolean jePotrebaZmenyPohybu()
    {
        return this.potrebaZmenyPohybu;
    }

    /**
     * Zmení smer pohybu všetkých aktívnych votrelcov a zruší potrebu zmeny smeru pohybu
     */
    public void zmenSmerPohybu()
    {
        int stlpec = 0;
        int riadok = 0;
        while (riadok < RIADKY) {
            while (stlpec < STLPCE) {
                this.votrelci[stlpec][riadok].zmenSmerPohybu();
                stlpec = stlpec + 1;
            }
            riadok = riadok + 1;
            stlpec = 0;
        }
        this.potrebaZmenyPohybu = false;
    }

    /**
     * Zníži počet evidovaných aktívnych votrelcov
     */
    public void znizPocetAktivnychVotrelcov(int kolko)
    {
        this.pocetAktivnychVotrelcov = this.pocetAktivnychVotrelcov - kolko;
        if (this.pocetAktivnychVotrelcov == 0) {
            this.vesmir.koniecHry();
        }
    }

    /**
     * Nájde posledného aktívneho votrelca v požadovanom stĺpci. Ak v stĺpci nie je žiadny aktívny votrelec, vráti null
     */
    public Votrelec dajPoslednehoVStlpci(int stlpec)
    {
        int riadok = RIADKY - 1;
        while (riadok >= 0) {
            Votrelec votrelec = this.votrelci[stlpec][riadok];
            if (votrelec.jeAktivny()) {
                return votrelec;
            }
            riadok = riadok - 1;
        }
        return null;
    }

    /**
     * Vráti zoznam votrelcov vhodných na bombardovanie
     */
    public ArrayList<Votrelec> dajBombarderov()
    {
        int stlpec = 0;
        ArrayList<Votrelec> votrelci =  new ArrayList < Votrelec > ();
        while (stlpec < STLPCE) {
            Votrelec votrelec = dajPoslednehoVStlpci(stlpec);
            if (votrelec != null) {
                votrelci.add(votrelec);
            }
            stlpec = stlpec + 1;
        }
        return votrelci;
    }

    /**
     * Nájde vhodného votrelca a zhodí bombu
     */
    public void bombarduj()
    {
        ArrayList<Votrelec> votrelci = dajBombarderov();
        Votrelec votrelec = votrelci.get(Greenfoot.getRandomNumber(votrelci.size()));
        Vesmir vesmir = votrelec.dajVesmir();
        Bomba bomba =  new Bomba();
        vesmir.pridajAktora(bomba, votrelec.dajPoziciuX(), votrelec.dajDolnuHranu());
    }
}
