// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Vesmírny aktor reprezentujúci obranný kanón ovládaný hráčom. Reaguje na stlačenie šípok vľavo a vpravo pohybom v príslušnom smere a na stlačenie medzerníka vystrelením strely. Iba jedna strela môže byť súčasne aktívna. Reaguje na zásah znížením počtu životov. Ak počet životov klesne na 0, hra končí.
 */
public class Kanon extends VesmirnyAktor
{
    private Strela strela;
    private ArrayList<Zivot> zivoty;

    /**
     * Vytvorí kanón bez životov
     */
    public Kanon()
    {
        this.zivoty =  new ArrayList < Zivot > ();
    }

    /**
     * Posunie kanón vľavo
     */
    public void akciaSipkaVlavo()
    {
        posunVlavo(2);
    }

    /**
     * Posunie kanón vpravo
     */
    public void akciaSipkaVpravo()
    {
        posunVpravo(2);
    }

    /**
     * Ak je stlačený medzerník, pokúsi sa vystreliť strelu
     */
    public void akcia()
    {
        if (jeStlacenyKlaves(Klaves.MEDZERNIK)) {
            vystrel();
        }
    }

    /**
     * Ak nie je aktívna strela, vystrelí novú strelu
     */
    public void vystrel()
    {
        if (strela == null || ! strela.jeAktivny()) {
            Vesmir vesmir = dajVesmir();
            this.strela =  new Strela();
            vesmir.pridajAktora(this.strela, dajPoziciuX(), dajHornuHranu());
        }
    }

    /**
     * Pridá život do zásobnika životov
     */
    public void pridajZivot()
    {
        Vesmir vesmir = dajVesmir();
        Zivot zivot =  new Zivot();
        this.zivoty.add(zivot);
        vesmir.pridajAktora(zivot, 5 + (this.zivoty.size() * (zivot.dajSirku() + 5)), 248);
    }

    /**
     * Zníži počet životov. Ak je po zásahu počet životov väčší ako 0, resetuje kanón a hra pokračuje. Ak počet životov klesne na 0, hra končí.
     */
    public void zasah()
    {
        Vesmir vesmir = dajVesmir();
        if (this.zivoty.size() > 1) {
            Zivot zivot = this.zivoty.remove(this.zivoty.size() - 1);
            vesmir.odstranAktora(zivot);
            vesmir.odstranBomby();
            Greenfoot.delay(100);
            nastavPoziciu(vesmir.dajSirku() / 2, dajPoziciuY());
        }
        else {
            vesmir.koniecHry();
        }
    }
}
