// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Vesmír s útočnikmi a pozemnou obranou
 */
public class Vesmir extends World
{
    private Formacia formacia;
    private Kanon kanon;
    private Zem zem;
    private Ufo ufo;
    private Bunker[] bunkre;
    private int skore;
    private int casUfo;
    private int pocitadloUfo;
    private int casBomba;
    private int pocitadloBomba;
    private int pocitadloSkoreNaZivot;

    /**
     * Vytvorí vesmír s formáciou votrelcov a kanónom s bunkrami
     */
    public Vesmir()
    {
        super(224, 256, 1);
        this.formacia =  new Formacia(this);
        this.kanon =  new Kanon();
        this.zem =  new Zem();
        pridajAktora(this.kanon, dajSirku() / 2, 230);
        pridajAktora(this.zem, dajSirku() / 2, 240);
        vytvorBunkre();
        naplanujUfo();
        naplanujBombardovanie();
        zobrazSkore();
        int pocitadlo = 0;
        while (pocitadlo < 3) {
            this.kanon.pridajZivot();
            pocitadlo = pocitadlo + 1;
        }
    }

    /**
     * Vykoná akciu
     */
    public void act()
    {
        akcia();
    }

    /**
     * Vráti výšku vesmíru
     */
    final public int dajVysku()
    {
        return getHeight();
    }

    /**
     * Vráti šírku vesmíru
     */
    final public int dajSirku()
    {
        return getWidth();
    }

    /**
     * Pridá aktora do vesmíru
     */
    final public void pridajAktora(Actor aktor, int poziciaX, int poziciaY)
    {
        addObject(aktor, poziciaX, poziciaY);
    }

    /**
     * Odstráni aktora z vesmíru
     */
    final public void odstranAktora(Actor aktor)
    {
        removeObject(aktor);
    }

    /**
     * Zobrazí požadovaný text na pozícii X,Y
     */
    final public void zobrazText(String text, int poziciaX, int poziciaY)
    {
        showText(text, poziciaX, poziciaY);
    }

    /**
     * Vykoná akciu. Ak je potrebné zmeni smer pohybu formáciu. Ak je potrebné vytvorí ufo.
     */
    public void akcia()
    {
        if (this.formacia.jePotrebaZmenyPohybu()) {
            this.formacia.zmenSmerPohybu();
        }
        if (this.ufo == null || ! this.ufo.jeAktivny()) {
            this.pocitadloUfo = this.pocitadloUfo + 1;
            if (this.pocitadloUfo == this.casUfo) {
                if (Greenfoot.getRandomNumber(2) == 1) {
                    this.ufo =  new Ufo(true);
                    pridajAktora(ufo, 0, 30);
                }
                else {
                    this.ufo =  new Ufo(false);
                    pridajAktora(ufo, dajSirku(), 30);
                }
            }
        }
        if (this.pocitadloBomba == this.casBomba) {
            this.formacia.bombarduj();
            naplanujBombardovanie();
        }
        this.pocitadloBomba = this.pocitadloBomba + 1;
    }

    /**
     * Zobrazí aktuálne skóre vľavom hornom rohu v tvare 0000
     */
    public void zobrazSkore()
    {
        zobrazText(String.format("%1$04d", this.skore), 25, 10);
    }

    /**
     * Pridá hodnotu k atuálnemu skóre. Za každých 1000 skóre daruje kanónu jeden život
     */
    public void pridajSkore(int kolko)
    {
        this.skore = this.skore + kolko;
        zobrazSkore();
        this.pocitadloSkoreNaZivot = this.pocitadloSkoreNaZivot + kolko;
        if (this.pocitadloSkoreNaZivot > 1000) {
            this.kanon.pridajZivot();
            this.pocitadloSkoreNaZivot = this.pocitadloSkoreNaZivot % 1000;
        }
    }

    /**
     * Naplánuje príchod ufa a spustí časovač
     */
    public void naplanujUfo()
    {
        this.casUfo = Greenfoot.getRandomNumber(200) + 100;
        this.pocitadloUfo = 0;
    }

    /**
     * Naplánuje vyhodenie bomby útočnikmi a spustí časovač
     */
    public void naplanujBombardovanie()
    {
        this.casBomba = Greenfoot.getRandomNumber(250) + 10;
        this.pocitadloBomba = 0;
    }

    /**
     * Ukončí hru a zobrazí text KONIEC HRY
     */
    public void koniecHry()
    {
        zobrazText("KONIEC HRY", 150, 10);
        Greenfoot.stop();
    }

    /**
     * Pripraví bunkre pre obranu
     */
    public void vytvorBunkre()
    {
        this.bunkre =  new Bunker[4];
        int pocitadlo = 0;
        while (pocitadlo < this.bunkre.length) {
            Bunker bunker =  new Bunker(this, 28 + (pocitadlo * 50), 200);
            pocitadlo = pocitadlo + 1;
        }
    }

    /**
     * Odstráni všetky padajúce bomby
     */
    public void odstranBomby()
    {
        List<Bomba> bomby = getObjects(Bomba.class);
        for (final Bomba bomba : bomby) {
            odstranAktora(bomba);
        }
    }
}
