// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Aktor, ktorý reaguje na stlačenie šípok. Dokáže meniť svoju polohu a obrázok. Poskytuje informácie o svojej polohe, rozmeroch a aktivite.
 */
public class VesmirnyAktor extends Actor
{

    /**
     * Metóda definujúca správanie aktora. Najskôr zareaguje na akciu stlačenia kláves a potom vykoná akciu.
     */
    public void act()
    {
        if (Greenfoot.isKeyDown("up")) {
            akciaSipkaHore();
        }
        if (Greenfoot.isKeyDown("down")) {
            akciaSipkaDole();
        }
        if (Greenfoot.isKeyDown("left")) {
            akciaSipkaVlavo();
        }
        if (Greenfoot.isKeyDown("right")) {
            akciaSipkaVpravo();
        }
        akcia();
    }

    /**
     * Vráti X-ovú súradniu stredu aktora
     */
    final public int dajPoziciuX()
    {
        return getX();
    }

    /**
     * Vráti Y-ovú sáradniu stredu aktora
     */
    final public int dajPoziciuY()
    {
        return getY();
    }

    /**
     * Vráti širku aktora
     */
    final public int dajSirku()
    {
        return getImage().getWidth();
    }

    /**
     * Vráti výšku aktora
     */
    final public int dajVysku()
    {
        return getImage().getHeight();
    }

    /**
     * Vráti Y-ovú súradnicu hornej hrany aktora
     */
    final public int dajHornuHranu()
    {
        return getY() - (getImage().getHeight() / 2);
    }

    /**
     * Vráti Y-ovú súradnicu dolnej hrany aktora
     */
    final public int dajDolnuHranu()
    {
        return getY() + (getImage().getHeight() / 2);
    }

    /**
     * Vráti X-ovú súradnicu ľavej hrany aktora
     */
    final public int dajLavuHranu()
    {
        return getX() - (getImage().getWidth() / 2);
    }

    /**
     * Vráti X-ovú súradnicu pravej hrany aktora
     */
    final public int dajPravuHranu()
    {
        return getX() + (getImage().getWidth() / 2);
    }

    /**
     * Vráti vesmír, v ktorom sa aktor nachádza. Ak sa vo vesmíre nenachádza, vráti null
     */
    final public Vesmir dajVesmir()
    {
        return getWorldOfType(Vesmir.class);
    }

    /**
     * Nastaví pozíciu aktora na súradnice X,Y
     */
    final public void nastavPoziciu(int x, int y)
    {
        setLocation(x, y);
    }

    /**
     * Nastaví požadovaný obrázok aktorovi
     */
    final public void nastavObrazok(String nazovObrazka)
    {
        setImage(nazovObrazka);
    }

    /**
     * Nastaví požadovaný obrázok aktorovi
     */
    final public void nastavObrazok(GreenfootImage obrazok)
    {
        setImage(obrazok);
    }

    /**
     * Posunie aktora po X-ovej osi vľavo
     */
    public void posunVlavo(int kolko)
    {
        setLocation(getX() - kolko, getY());
    }

    /**
     * Posunie aktora po X-ovej osi vpravo
     */
    final public void posunVpravo(int kolko)
    {
        setLocation(getX() + kolko, getY());
    }

    /**
     * Posunie aktora po Y-ovej osi dole
     */
    final public void posunDole(int kolko)
    {
        setLocation(getX(), getY() + kolko);
    }

    /**
     * Posunie aktora po Y-ovej osi hore
     */
    final public void posunHore(int kolko)
    {
        setLocation(getX(), getY() - kolko);
    }

    /**
     * Zistí, či je aktor aktívny vo vesmíre
     */
    final public boolean jeAktivny()
    {
        return dajVesmir() != null;
    }

    /**
     * Zistí, či sa aktor dotýka horného okraja vesmíru
     */
    final public boolean jeNaHornomOkraji()
    {
        return dajHornuHranu() <= 0;
    }

    /**
     * Zistí, či sa aktor dotýka dolného okraja vesmíru
     */
    final public boolean jeNaDolnomOkraji()
    {
        return dajDolnuHranu() >= dajVesmir().dajVysku();
    }

    /**
     * Zistí, či sa aktor dotýka ľavého okraja vesmíru
     */
    final public boolean jeNaLavomOkraji()
    {
        return dajLavuHranu() <= 0;
    }

    /**
     * Zistí, či sa aktor dotýka pravého okraja vesmíru
     */
    final public boolean jeNaPravomOkraji()
    {
        return dajPravuHranu() >= dajVesmir().dajSirku();
    }

    /**
     * Zistí, či je stlačený požadovaný kláves - použi konštanty z triedy Klaves
     */
    final public boolean jeStlacenyKlaves(String klaves)
    {
        return Greenfoot.isKeyDown(klaves);
    }

    /**
     * Pravidelne vykonávaná akcia - viď metódu act
     */
    public void akcia()
    {
    }

    /**
     * Pravidelne vykonávaná akcia, ak je stlačená šípka nahor - viď metódu act
     */
    public void akciaSipkaHore()
    {
    }

    /**
     * Pravidelne vykonávaná akcia, ak je stlačená šípka nadol - viď metódu act
     */
    public void akciaSipkaDole()
    {
    }

    /**
     * Pravidelne vykonávaná akcia, ak je stlačená šípka vľavo - viď metódu act
     */
    public void akciaSipkaVlavo()
    {
    }

    /**
     * Pravidelne vykonávaná akcia, ak je stlačená šípka vpravo - viď metódu act
     */
    public void akciaSipkaVpravo()
    {
    }
}
