// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * Vesmírny aktor reprezentujúci votrelca troch rôznych typov (GENERAL, KAPITAN, VOJAK). Automaticky sa pohybuje zľava doprava resp. zprava doľava. Po zmene smeru pohybu sa posunie automaticky smerom ku Zemy a zrýchly svoj pohyb. Reaguje na zásah navýšením skóre a odstránením sa z vesmíru. Detekuje náraz na zem alebo kanón. Po náraze hra končí.
 */
public class Votrelec extends VesmirnyAktor
{
    public static final int GENERAL = 1;
    public static final int KAPITAN = 2;
    public static final int VOJAK = 3;
    private Formacia formacia;
    private int typ;
    private boolean smerPohybu;
    private boolean zmenilSaSmer;
    private int rychlost;
    private int pocitadlo;
    private boolean stavPohybu;
    private GreenfootImage[] obrazky;
    private int skore;

    /**
     * Vytvorí votrelca podľa požadovaného typu a zaradí ho do formácie. Pohyb začína smerom zprava doľava.
     */
    public Votrelec(Formacia formacia, int typ)
    {
        this.typ = typ;
        this.formacia = formacia;
        this.rychlost = 50;
        this.pocitadlo = 0;
        this.obrazky =  new GreenfootImage[2];
        nastavObrazkyASkore();
        zmenObrazok();
    }

    /**
     * Nastaví obrázky stavu votrelca a jeho skóre podľa jeho typu
     */
    private void nastavObrazkyASkore()
    {
        switch (this.typ) {
            case GENERAL : {
                this.obrazky[0] =  new GreenfootImage("images\\votrelec1_0.png");
                this.obrazky[1] =  new GreenfootImage("images\\votrelec1_1.png");
                this.skore = 30;
                break;
            }
            case KAPITAN : {
                this.obrazky[0] =  new GreenfootImage("images\\votrelec2_0.png");
                this.obrazky[1] =  new GreenfootImage("images\\votrelec2_1.png");
                this.skore = 20;
                break;
            }
            case VOJAK : {
                this.obrazky[0] =  new GreenfootImage("images\\votrelec3_0.png");
                this.obrazky[1] =  new GreenfootImage("images\\votrelec3_1.png");
                this.skore = 10;
                break;
            }
        }
    }

    /**
     * Vykoná pohyb podľa nastaveného smeru. Ak dosiahne ľavú resp. pravú hranu vesmíru, notifikuje formáciu o potrebe zmeny smeru pohybu. Ak zistí zmenu smeru pohybu, posunie sa smerom ku Zemy a zmení smer pohybu. Ak detekuje náraz do kanóna alebo na Zem, hra končí.
     */
    public void akcia()
    {
        if (this.pocitadlo == this.rychlost) {
            if (this.smerPohybu) {
                posunVpravo(5);
            }
            else {
                posunVlavo(5);
            }
            if (this.zmenilSaSmer) {
                posunDole(5);
                this.zmenilSaSmer = false;
            }
            if (narazil()) {
                Vesmir vesmir = dajVesmir();
                vesmir.koniecHry();
            }
            if (jeNaLavomOkraji() || jeNaPravomOkraji()) {
                if (this.formacia != null) {
                    this.formacia.nastavPotrebuZmenyPohybu();
                }
                else {
                    zmenSmerPohybu();
                }
            }
            zmenObrazok();
            this.pocitadlo = 0;
        }
        this.pocitadlo = this.pocitadlo + 1;
    }

    /**
     * Prepína medzi obrázkami stavu pohybu
     */
    public void zmenObrazok()
    {
        if (this.stavPohybu) {
            nastavObrazok(this.obrazky[1]);
            this.stavPohybu = false;
        }
        else {
            nastavObrazok(this.obrazky[0]);
            this.stavPohybu = true;
        }
    }

    /**
     * Zmení smer pohybu a zrýchly pohyb
     */
    public void zmenSmerPohybu()
    {
        this.smerPohybu =  ! this.smerPohybu;
        this.zmenilSaSmer = true;
        if (this.rychlost > 10) {
            this.rychlost = this.rychlost - 5;
        }
    }

    /**
     * Pridá skóre a odstráni sa z vesmíru
     */
    public void zasah()
    {
        Vesmir vesmir = dajVesmir();
        vesmir.pridajSkore(this.skore);
        this.formacia.znizPocetAktivnychVotrelcov(1);
        vesmir.odstranAktora(this);
    }

    /**
     * Zistí náraz do kanóna alebo na Zem
     */
    public boolean narazil()
    {
        Kanon kanon = (Kanon)getOneIntersectingObject(Kanon.class);
        if (kanon != null) {
            return true;
        }
        Zem zem = (Zem)getOneIntersectingObject(Zem.class);
        if (zem != null) {
            return true;
        }
        return false;
    }
}
